Index: branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectResourcesView.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectResourcesView.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectResourcesView.cs	(revision 16518)
@@ -29,6 +29,4 @@
 using HeuristicLab.Core.Views;
 using HeuristicLab.MainForm;
-using System.Collections;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Clients.Hive.Administrator.Views {
@@ -79,10 +77,4 @@
 
     #region Overrides
-    protected override void OnClosing(FormClosingEventArgs e) {
-      HiveAdminClient.Instance.Refreshed -= HiveAdminClient_Instance_Refreshed;
-      HiveAdminClient.Instance.Refreshing -= HiveAdminClient_Instance_Refreshing;
-      base.OnClosing(e);
-    }
-
     protected override void OnContentChanged() {
       base.OnContentChanged();
@@ -130,6 +122,7 @@
     }
 
-    private void ProjectResourcesView_Load(object sender, EventArgs e) {
-
+    private void ProjectResourcesView_Disposed(object sender, EventArgs e) {
+      HiveAdminClient.Instance.Refreshed -= HiveAdminClient_Instance_Refreshed;
+      HiveAdminClient.Instance.Refreshing -= HiveAdminClient_Instance_Refreshing;
     }
 
@@ -165,5 +158,5 @@
 
       var selectedResource = (Resource)e.Node.Tag;
-      if(HiveAdminClient.Instance.DisabledParentResources.Contains(selectedResource))
+      if (HiveAdminClient.Instance.DisabledParentResources.Contains(selectedResource))
         e.Cancel = true;
     }
@@ -179,17 +172,17 @@
         return;
       }
-        
+
       var checkedResource = (Resource)e.Node.Tag;
       if (checkedResource == null
         || checkedResource.Id == Guid.Empty
-        || HiveAdminClient.Instance.DisabledParentResources.Contains(checkedResource) 
+        || HiveAdminClient.Instance.DisabledParentResources.Contains(checkedResource)
         || newIncludedResources.Contains(checkedResource)) {
         e.Cancel = true;
       } else if (!IsAdmin()) {
-          if (!HiveAdminClient.Instance.CheckOwnershipOfParentProject(Content, UserInformation.Instance.User.Id) 
-            || !HiveAdminClient.Instance.GetAvailableProjectAncestors(Content.Id).Any() 
-            || projectExclusiveResources.Contains(checkedResource)) {
-            e.Cancel = true;
-          }
+        if (!HiveAdminClient.Instance.CheckOwnershipOfParentProject(Content, UserInformation.Instance.User.Id)
+          || !HiveAdminClient.Instance.GetAvailableProjectAncestors(Content.Id).Any()
+          || projectExclusiveResources.Contains(checkedResource)) {
+          e.Cancel = true;
+        }
       }
     }
@@ -232,5 +225,5 @@
 
       // get project specific assigned resources
-      var projectResources = resources.Where(x => 
+      var projectResources = resources.Where(x =>
         HiveAdminClient.Instance.ProjectResourceAssignments
           .Where(a => a.ProjectId == projectId)
@@ -242,5 +235,5 @@
       HiveAdminClient.Instance.GetAvailableProjectAncestors(projectId).ToList().ForEach(x => projectIds.Add(x.Id));
 
-      var ancestorProjectResources = resources.Where(x => 
+      var ancestorProjectResources = resources.Where(x =>
         HiveAdminClient.Instance.ProjectResourceAssignments
           .Where(a => projectIds.Contains(a.ProjectId))
@@ -251,5 +244,5 @@
       HashSet<Resource> availableResources = new HashSet<Resource>(ancestorProjectResources);
       foreach (var r in ancestorProjectResources) {
-        foreach(var d in HiveAdminClient.Instance.GetAvailableResourceDescendants(r.Id)) {
+        foreach (var d in HiveAdminClient.Instance.GetAvailableResourceDescendants(r.Id)) {
           availableResources.Add(d);
         }
@@ -267,5 +260,5 @@
           foreach (var d in HiveAdminClient.Instance.GetAvailableResourceDescendants(r.Id)) {
             projectExclusiveResources.Add(d);
-          }  
+          }
         }
       }
@@ -286,11 +279,11 @@
       if (projectId == null || resourceIds == null) return;
       HiveServiceLocator.Instance.CallHiveService(s => {
-       s.SaveProjectResourceAssignments(projectId, resourceIds.ToList(), reassign, cascading, reassignCascading);
+        s.SaveProjectResourceAssignments(projectId, resourceIds.ToList(), reassign, cascading, reassignCascading);
       });
     }
 
     private void UpdateNewAssignedResources() {
-      for(int i = newAssignedResources.Count -1; i >= 0; i--) {
-        if(newAssignedResources.Intersect(HiveAdminClient.Instance.GetAvailableResourceAncestors(newAssignedResources.ElementAt(i).Id)).Any()) {
+      for (int i = newAssignedResources.Count - 1; i >= 0; i--) {
+        if (newAssignedResources.Intersect(HiveAdminClient.Instance.GetAvailableResourceAncestors(newAssignedResources.ElementAt(i).Id)).Any()) {
           newAssignedResources.Remove(newAssignedResources.ElementAt(i));
         }
@@ -345,5 +338,5 @@
 
       var stack = new Stack<Resource>(mainResources.OrderByDescending(x => x.Name));
-      
+
       Resource top = null;
       //bool nodeSelected = false;
@@ -352,5 +345,5 @@
         top = resources.Where(x => x.Id == resourceId).FirstOrDefault();
       }
-      
+
 
       TreeNode currentNode = null;
@@ -366,5 +359,5 @@
         var newNode = new TreeNode(newResource.Name) { Tag = newResource };
 
-        if(top == null && !disabledParentResources.Contains(newResource)) {
+        if (top == null && !disabledParentResources.Contains(newResource)) {
           top = newResource;
         }
@@ -395,7 +388,7 @@
         } else if (newAssignedResources.Contains(newResource)) {
           newNode.Checked = true;
-          if(!HiveRoles.CheckAdminUserPermissions()) {
-            if (!HiveAdminClient.Instance.CheckOwnershipOfParentProject(Content, UserInformation.Instance.User.Id) 
-              || !HiveAdminClient.Instance.GetAvailableProjectAncestors(Content.Id).Any() 
+          if (!HiveRoles.CheckAdminUserPermissions()) {
+            if (!HiveAdminClient.Instance.CheckOwnershipOfParentProject(Content, UserInformation.Instance.User.Id)
+              || !HiveAdminClient.Instance.GetAvailableProjectAncestors(Content.Id).Any()
               || projectExclusiveResources.Contains(newResource)) {
               newNode.ForeColor = SystemColors.GrayText;
@@ -452,5 +445,5 @@
       bool expandUngroupedGroupNode = false;
       var ungroupedSlaves = subResources.OfType<Slave>().OrderBy(x => x.Name);
-      if(ungroupedSlaves.Any()) {
+      if (ungroupedSlaves.Any()) {
         ungroupedGroupNode = new TreeNode(UNGROUPED_GROUP_NAME) {
           ForeColor = SystemColors.GrayText,
@@ -486,5 +479,5 @@
         }
 
-        if(expandUngroupedGroupNode) ungroupedGroupNode.Expand();
+        if (expandUngroupedGroupNode) ungroupedGroupNode.Expand();
         treeView.Nodes.Add(ungroupedGroupNode);
       } else if (ungroupedGroupNode != null) {
@@ -493,5 +486,5 @@
 
       treeView.BeforeCheck += treeView_BeforeCheck;
-      treeView.AfterCheck += treeView_AfterCheck;          
+      treeView.AfterCheck += treeView_AfterCheck;
 
       return top;
Index: branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.Designer.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.Designer.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.Designer.cs	(revision 16518)
@@ -213,4 +213,5 @@
       this.Size = new System.Drawing.Size(539, 271);
       this.Load += new System.EventHandler(this.ProjectView_Load);
+      this.Disposed += new System.EventHandler(this.ProjectView_Disposed);
       this.ResumeLayout(false);
       this.PerformLayout();
Index: branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectView.cs	(revision 16518)
@@ -35,9 +35,7 @@
     private readonly object locker = new object();
 
-    private Guid persistedOwnerUserId;
-
     public new Project Content {
       get { return (Project)base.Content; }
-      set { base.Content = value; persistedOwnerUserId = Content != null ? Content.OwnerUserId : Guid.Empty; }
+      set { base.Content = value; }
     }
 
@@ -50,10 +48,4 @@
 
     #region Overrides
-    protected override void OnClosing(FormClosingEventArgs e) {
-      AccessClient.Instance.Refreshed -= AccessClient_Instance_Refreshed;
-      AccessClient.Instance.Refreshing -= AccessClient_Instance_Refreshing;
-      base.OnClosing(e);
-    }
-
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
@@ -104,8 +96,11 @@
 
         ownerComboBox.SelectedIndexChanged -= ownerComboBox_SelectedIndexChanged;
-        var users = AccessClient.Instance.UsersAndGroups.OfType<LightweightUser>();
-        if (!Content.ParentProjectId.HasValue) users = users.Where(x => x.Roles.Select(y => y.Name).Contains(HiveRoles.Administrator));
-        ownerComboBox.DataSource = users.ToList();
-        ownerComboBox.SelectedItem = users.FirstOrDefault(x => x.Id == Content.OwnerUserId);
+        if (AccessClient.Instance.UsersAndGroups != null) {
+          var users = AccessClient.Instance.UsersAndGroups.OfType<LightweightUser>();
+          if (!Content.ParentProjectId.HasValue) users = users.Where(x => x.Roles.Select(y => y.Name).Contains(HiveRoles.Administrator));
+          var projectOwnerId = Content.OwnerUserId;
+          ownerComboBox.DataSource = users.OrderBy(x => x.UserName).ToList();
+          ownerComboBox.SelectedItem = users.FirstOrDefault(x => x.Id == projectOwnerId);
+        }
         ownerComboBox.SelectedIndexChanged += ownerComboBox_SelectedIndexChanged;
 
@@ -180,7 +175,12 @@
           var users = AccessClient.Instance.UsersAndGroups.OfType<LightweightUser>();
           if (Content != null && !Content.ParentProjectId.HasValue) users = users.Where(x => x.Roles.Select(y => y.Name).Contains(HiveRoles.Administrator));
-          ownerComboBox.DataSource = users.ToList();
+          ownerComboBox.DataSource = users.OrderBy(x => x.UserName).ToList();
           ownerComboBox.SelectedIndexChanged += ownerComboBox_SelectedIndexChanged;
         });
+    }
+
+    private void ProjectView_Disposed(object sender, EventArgs e) {
+      AccessClient.Instance.Refreshed -= AccessClient_Instance_Refreshed;
+      AccessClient.Instance.Refreshing -= AccessClient_Instance_Refreshing;
     }
 
Index: branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs	(revision 16518)
@@ -260,4 +260,5 @@
       this.Size = new System.Drawing.Size(853, 553);
       this.Load += new System.EventHandler(this.ProjectsView_Load);
+      this.Disposed += new System.EventHandler(this.ProjectsView_Disposed);
       this.splitContainer.Panel1.ResumeLayout(false);
       this.splitContainer.Panel2.ResumeLayout(false);
Index: branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.cs	(revision 16518)
@@ -56,4 +56,6 @@
 
     private readonly object locker = new object();
+    private bool refreshingInternal = false;
+    private bool refreshingExternal = false;
 
     public new IItemList<Project> Content {
@@ -70,17 +72,7 @@
       HiveAdminClient.Instance.Refreshing += HiveAdminClient_Instance_Refreshing;
       HiveAdminClient.Instance.Refreshed += HiveAdminClient_Instance_Refreshed;
-      AccessClient.Instance.Refreshing += AccessClient_Instance_Refreshing;
-      AccessClient.Instance.Refreshed += AccessClient_Instance_Refreshed;
     }
 
     #region Overrides
-    protected override void OnClosing(FormClosingEventArgs e) {
-      AccessClient.Instance.Refreshed -= AccessClient_Instance_Refreshed;
-      AccessClient.Instance.Refreshing -= AccessClient_Instance_Refreshing;
-      HiveAdminClient.Instance.Refreshed -= HiveAdminClient_Instance_Refreshed;
-      HiveAdminClient.Instance.Refreshing -= HiveAdminClient_Instance_Refreshing;
-      base.OnClosing(e);
-    }
-
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
@@ -183,4 +175,9 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveAdminClient_Instance_Refreshing, sender, e);
       else {
+        lock (locker) {
+          if (refreshingExternal) return;
+          if (!refreshingInternal) refreshingExternal = true;
+        }
+
         Progress.Show(this, "Refreshing ...", ProgressMode.Indeterminate);
         SetEnabledStateOfControls();
@@ -191,20 +188,7 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveAdminClient_Instance_Refreshed, sender, e);
       else {
-        Progress.Hide(this);
-        SetEnabledStateOfControls();
-      }
-    }
-
-    private void AccessClient_Instance_Refreshing(object sender, EventArgs e) {
-      if (InvokeRequired) Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshing, sender, e);
-      else {
-        Progress.Show(this, "Refreshing ...", ProgressMode.Indeterminate);
-        SetEnabledStateOfControls();
-      }
-    }
-
-    private void AccessClient_Instance_Refreshed(object sender, EventArgs e) {
-      if (InvokeRequired) Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshed, sender, e);
-      else {
+        if (refreshingExternal) refreshingExternal = false;
+        Content = HiveAdminClient.Instance.Projects;
+
         Progress.Hide(this);
         SetEnabledStateOfControls();
@@ -215,4 +199,9 @@
       await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
         action: () => UpdateProjects());
+    }
+
+    private void ProjectsView_Disposed(object sender, EventArgs e) {
+      HiveAdminClient.Instance.Refreshed -= HiveAdminClient_Instance_Refreshed;
+      HiveAdminClient.Instance.Refreshing -= HiveAdminClient_Instance_Refreshing;
     }
 
@@ -515,9 +504,15 @@
 
     private void UpdateProjects() {
+      lock (locker) {
+        if (refreshingInternal || refreshingExternal) return;
+        refreshingInternal = true;
+      }
+
       try {
         HiveAdminClient.Instance.Refresh();
-        Content = HiveAdminClient.Instance.Projects;
       } catch (AnonymousUserException) {
         ShowHiveInformationDialog();
+      } finally {
+        refreshingInternal = false;
       }
     }
Index: branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.Designer.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.Designer.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.Designer.cs	(revision 16518)
@@ -239,4 +239,5 @@
       this.Size = new System.Drawing.Size(853, 553);
       this.Load += new System.EventHandler(this.ResourcesView_Load);
+      this.Disposed += new System.EventHandler(this.ResourcesView_Disposed);
       this.splitSlaves.Panel1.ResumeLayout(false);
       this.splitSlaves.Panel2.ResumeLayout(false);
Index: branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourcesView.cs	(revision 16518)
@@ -54,5 +54,4 @@
 
 
-
     private TreeNode ungroupedGroupNode;
 
@@ -64,4 +63,6 @@
 
     private readonly object locker = new object();
+    private bool refreshingInternal = false;
+    private bool refreshingExternal = false;
 
     public new IItemList<Resource> Content {
@@ -78,17 +79,7 @@
       HiveAdminClient.Instance.Refreshing += HiveAdminClient_Instance_Refreshing;
       HiveAdminClient.Instance.Refreshed += HiveAdminClient_Instance_Refreshed;
-      AccessClient.Instance.Refreshing += AccessClient_Instance_Refreshing;
-      AccessClient.Instance.Refreshed += AccessClient_Instance_Refreshed;
     }
 
     #region Overrides
-    protected override void OnClosing(FormClosingEventArgs e) {
-      AccessClient.Instance.Refreshed -= AccessClient_Instance_Refreshed;
-      AccessClient.Instance.Refreshing -= AccessClient_Instance_Refreshing;
-      HiveAdminClient.Instance.Refreshed -= HiveAdminClient_Instance_Refreshed;
-      HiveAdminClient.Instance.Refreshing -= HiveAdminClient_Instance_Refreshing;
-      base.OnClosing(e);
-    }
-
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
@@ -185,4 +176,9 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveAdminClient_Instance_Refreshing, sender, e);
       else {
+        lock (locker) {
+          if (refreshingExternal) return;
+          if (!refreshingInternal) refreshingExternal = true;
+        }
+
         Progress.Show(this, "Refreshing ...", ProgressMode.Indeterminate);
         SetEnabledStateOfControls();
@@ -193,4 +189,7 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveAdminClient_Instance_Refreshed, sender, e);
       else {
+        if (refreshingExternal) refreshingExternal = false;
+        Content = HiveAdminClient.Instance.Resources;
+
         Progress.Hide(this);
         SetEnabledStateOfControls();
@@ -198,23 +197,11 @@
     }
 
-    private void AccessClient_Instance_Refreshing(object sender, EventArgs e) {
-      if (InvokeRequired) Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshing, sender, e);
-      else {
-        Progress.Show(this, "Refreshing ...", ProgressMode.Indeterminate);
-        SetEnabledStateOfControls();
-      }
-    }
-
-    private void AccessClient_Instance_Refreshed(object sender, EventArgs e) {
-      if (InvokeRequired) Invoke((Action<object, EventArgs>)AccessClient_Instance_Refreshed, sender, e);
-      else {
-        Progress.Hide(this);
-        SetEnabledStateOfControls();
-      }
-    }
-
     private async void ResourcesView_Load(object sender, EventArgs e) {
-      await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
-        action: () => UpdateResources());
+      await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(() => UpdateResources());
+    }
+
+    private void ResourcesView_Disposed(object sender, EventArgs e) {
+      HiveAdminClient.Instance.Refreshed -= HiveAdminClient_Instance_Refreshed;
+      HiveAdminClient.Instance.Refreshing -= HiveAdminClient_Instance_Refreshing;
     }
 
@@ -550,9 +537,15 @@
 
     private void UpdateResources() {
+      lock (locker) {
+        if (refreshingInternal || refreshingExternal) return;
+        refreshingInternal = true;
+      }
+
       try {
         HiveAdminClient.Instance.Refresh();
-        Content = HiveAdminClient.Instance.Resources;
       } catch (AnonymousUserException) {
         ShowHiveInformationDialog();
+      } finally {
+        refreshingInternal = false;
       }
     }
Index: branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelectorDialog.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelectorDialog.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelectorDialog.cs	(revision 16518)
@@ -96,6 +96,9 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveClient_Instance_Refreshing, sender, e);
       else {
-        Progress.ShowOnControl(this, "Refreshing", ProgressMode.Indeterminate);
         refreshButton.Enabled = false;
+        okButton.Enabled = false;
+        cancelButton.Enabled = false;
+        // Progress cannot be shown on dialog (no parent control), thus it is shown on the selector
+        Progress.Show(hiveResourceSelector, "Refreshing", ProgressMode.Indeterminate);
       }
     }
@@ -104,5 +107,7 @@
       if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveClient_Instance_Refreshed, sender, e);
       else {
-        Progress.HideFromControl(this);
+        Progress.Hide(hiveResourceSelector);
+        okButton.Enabled = true;
+        cancelButton.Enabled = true;
         refreshButton.Enabled = true;
       }
Index: branches/2972_PDPRowSelect/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.Designer.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.Designer.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.Designer.cs	(revision 16518)
@@ -94,5 +94,5 @@
       // lstMethods
       // 
-      this.lstMethods.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+      this.lstMethods.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.lstMethods.FormattingEnabled = true;
@@ -122,5 +122,5 @@
       // grpBoxData
       // 
-      this.grpBoxData.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+      this.grpBoxData.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.grpBoxData.Controls.Add(this.tabsData);
@@ -134,5 +134,5 @@
       // tabsData
       // 
-      this.tabsData.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+      this.tabsData.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.tabsData.Controls.Add(this.tabPage1);
@@ -149,4 +149,5 @@
       // tabPage1
       // 
+      this.tabPage1.BackColor = System.Drawing.SystemColors.Window;
       this.tabPage1.Controls.Add(this.label7);
       this.tabPage1.Location = new System.Drawing.Point(4, 22);
@@ -156,6 +157,4 @@
       this.tabPage1.TabIndex = 5;
       this.tabPage1.Text = "tabDataInactive";
-      this.tabPage1.UseVisualStyleBackColor = true;
-      // 
       // label7
       // 
@@ -170,4 +169,5 @@
       // tabDataDeleteColumnsInformation
       // 
+      this.tabDataDeleteColumnsInformation.BackColor = System.Drawing.SystemColors.Window;
       this.tabDataDeleteColumnsInformation.Controls.Add(this.label2);
       this.tabDataDeleteColumnsInformation.Controls.Add(this.txtDeleteColumnsInfo);
@@ -179,5 +179,4 @@
       this.tabDataDeleteColumnsInformation.TabIndex = 0;
       this.tabDataDeleteColumnsInformation.Text = "del columns info";
-      this.tabDataDeleteColumnsInformation.UseVisualStyleBackColor = true;
       // 
       // label2
@@ -209,4 +208,5 @@
       // tabDataDeleteColumnsVariance
       // 
+      this.tabDataDeleteColumnsVariance.BackColor = System.Drawing.SystemColors.Window;
       this.tabDataDeleteColumnsVariance.Controls.Add(this.txtDeleteColumnsVariance);
       this.tabDataDeleteColumnsVariance.Controls.Add(this.label4);
@@ -217,5 +217,4 @@
       this.tabDataDeleteColumnsVariance.TabIndex = 1;
       this.tabDataDeleteColumnsVariance.Text = "del columns variance";
-      this.tabDataDeleteColumnsVariance.UseVisualStyleBackColor = true;
       // 
       // txtDeleteColumnsVariance
@@ -238,4 +237,5 @@
       // tabDataDeleteRowsInfo
       // 
+      this.tabDataDeleteRowsInfo.BackColor = System.Drawing.SystemColors.Window;
       this.tabDataDeleteRowsInfo.Controls.Add(this.label3);
       this.tabDataDeleteRowsInfo.Controls.Add(this.txtDeleteRowsInfo);
@@ -247,5 +247,4 @@
       this.tabDataDeleteRowsInfo.TabIndex = 2;
       this.tabDataDeleteRowsInfo.Text = "del rows info";
-      this.tabDataDeleteRowsInfo.UseVisualStyleBackColor = true;
       // 
       // label3
@@ -277,6 +276,6 @@
       // grpBoxPreview
       // 
-      this.grpBoxPreview.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.grpBoxPreview.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.grpBoxPreview.Controls.Add(this.tabsPreview);
@@ -290,5 +289,5 @@
       // tabsPreview
       // 
-      this.tabsPreview.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+      this.tabsPreview.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.tabsPreview.Controls.Add(this.tabPreviewInactive);
@@ -305,4 +304,5 @@
       // tabPreviewInactive
       // 
+      this.tabPreviewInactive.BackColor = System.Drawing.SystemColors.Window;
       this.tabPreviewInactive.Controls.Add(this.lblPreviewInActive);
       this.tabPreviewInactive.Location = new System.Drawing.Point(4, 22);
@@ -312,5 +312,4 @@
       this.tabPreviewInactive.TabIndex = 5;
       this.tabPreviewInactive.Text = "inactive";
-      this.tabPreviewInactive.UseVisualStyleBackColor = true;
       // 
       // lblPreviewInActive
@@ -327,4 +326,5 @@
       // tabPreviewDeleteColumnsInfo
       // 
+      this.tabPreviewDeleteColumnsInfo.BackColor = System.Drawing.SystemColors.Window;
       this.tabPreviewDeleteColumnsInfo.Controls.Add(this.panel1);
       this.tabPreviewDeleteColumnsInfo.Location = new System.Drawing.Point(4, 22);
@@ -334,5 +334,4 @@
       this.tabPreviewDeleteColumnsInfo.TabIndex = 0;
       this.tabPreviewDeleteColumnsInfo.Text = "del columns info";
-      this.tabPreviewDeleteColumnsInfo.UseVisualStyleBackColor = true;
       // 
       // panel1
@@ -359,4 +358,5 @@
       // tabPreviewDeleteColumnsVariance
       // 
+      this.tabPreviewDeleteColumnsVariance.BackColor = System.Drawing.SystemColors.Window;
       this.tabPreviewDeleteColumnsVariance.Controls.Add(this.panel2);
       this.tabPreviewDeleteColumnsVariance.Controls.Add(this.label12);
@@ -367,5 +367,4 @@
       this.tabPreviewDeleteColumnsVariance.TabIndex = 1;
       this.tabPreviewDeleteColumnsVariance.Text = "del columns variance";
-      this.tabPreviewDeleteColumnsVariance.UseVisualStyleBackColor = true;
       // 
       // panel2
@@ -400,4 +399,5 @@
       // tabPreviewDeleteRowsInfo
       // 
+      this.tabPreviewDeleteRowsInfo.BackColor = System.Drawing.SystemColors.Window;
       this.tabPreviewDeleteRowsInfo.Controls.Add(this.lblPreviewRowsInfo);
       this.tabPreviewDeleteRowsInfo.Location = new System.Drawing.Point(4, 22);
@@ -407,5 +407,4 @@
       this.tabPreviewDeleteRowsInfo.TabIndex = 2;
       this.tabPreviewDeleteRowsInfo.Text = "del rows info";
-      this.tabPreviewDeleteRowsInfo.UseVisualStyleBackColor = true;
       // 
       // lblPreviewRowsInfo
Index: branches/2972_PDPRowSelect/HeuristicLab.DataPreprocessing.Views/3.4/SearchAndReplaceDialog.Designer.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.DataPreprocessing.Views/3.4/SearchAndReplaceDialog.Designer.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.DataPreprocessing.Views/3.4/SearchAndReplaceDialog.Designer.cs	(revision 16518)
@@ -79,4 +79,5 @@
       // tabSearch
       // 
+      this.tabSearch.BackColor = System.Drawing.SystemColors.Window;
       this.tabSearch.Location = new System.Drawing.Point(4, 22);
       this.tabSearch.Name = "tabSearch";
@@ -85,8 +86,8 @@
       this.tabSearch.TabIndex = 0;
       this.tabSearch.Text = "Search";
-      this.tabSearch.UseVisualStyleBackColor = true;
       // 
       // tabReplace
       // 
+      this.tabReplace.BackColor = System.Drawing.SystemColors.Window;
       this.tabReplace.Controls.Add(this.cmbComparisonOperator);
       this.tabReplace.Controls.Add(this.txtSearchString);
@@ -106,5 +107,4 @@
       this.tabReplace.TabIndex = 1;
       this.tabReplace.Text = "Replace";
-      this.tabReplace.UseVisualStyleBackColor = true;
       // 
       // cmbComparisonOperator
Index: branches/2972_PDPRowSelect/HeuristicLab.MainForm.WindowsForms/3.3/Controls/ControlExtensions.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.MainForm.WindowsForms/3.3/Controls/ControlExtensions.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.MainForm.WindowsForms/3.3/Controls/ControlExtensions.cs	(revision 16518)
@@ -46,19 +46,4 @@
       }
     }
-
-    public static IEnumerable<Control> GetNestedControls(this Control control, Func<Control, bool> condition = null) {
-      if (control == null) yield break;
-      if (condition == null) condition = (c) => true;
-
-      Queue<Control> unprocessed = new Queue<Control>();
-      unprocessed.Enqueue(control);
-
-      while (unprocessed.Count > 0) {
-        Control c = unprocessed.Dequeue();
-        if (condition(c)) yield return c;
-        foreach (Control child in c.Controls)
-          unprocessed.Enqueue(child);
-      }
-    }
   }
 }
Index: branches/2972_PDPRowSelect/HeuristicLab.MainForm.WindowsForms/3.3/Controls/ProgressView.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.MainForm.WindowsForms/3.3/Controls/ProgressView.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.MainForm.WindowsForms/3.3/Controls/ProgressView.cs	(revision 16518)
@@ -38,4 +38,5 @@
       : base() {
       if (control == null) throw new ArgumentNullException("control");
+      if (control.Parent == null) throw new InvalidOperationException("A Progress can only be shown on controls that have a Parent-control. Therefore, Dialogs and Forms cannot have an associated ProgressView.");
       if (content == null) throw new ArgumentNullException("content");
       InitializeComponent();
@@ -114,7 +115,9 @@
       UpdateButtonsState();
 
+      Control.SuspendRepaint();
       Control.Enabled = false;
       Parent = Control.Parent;
       BringToFront();
+      Control.ResumeRepaint(true);
       Visible = true;
     }
@@ -128,5 +131,7 @@
 
       Visible = false;
+      Control.SuspendRepaint();
       Control.Enabled = true;
+      Control.ResumeRepaint(true);
       Parent = null;
     }
